routes/web.php
<?php
/**
 * Auth Routes
 */
Auth::routes();

/**
 * Routes Users.
 */
Route::resource('usuarios', 'UserController');

/**
 * Routes ACL.
 */
Route::resource('permissoes', 'ACL\PermissionController');
Route::resource('perfis', 'ACL\ProfileController');


Route::get('plans/{slug}/profiles', 'ACL\PlanProfileController@profiles')->name('plans.profiles');
Route::get('plans/{slug}/profiles/create', 'ACL\PlanProfileController@profilesAvailable');
Route::post('plans/{slug}/profiles/store', 'ACL\PlanProfileController@attachPermissionsProfile');
Route::get('plans/{slug}/profile/{id}/detach', 'ACL\PlanProfileController@detachPermissionsProfile');
/**
 * Adicionar e remover permissões aos perfis
 */
Route::get('profile/{slug}/permissions', 'ACL\ProfilePermissionController@permissions')->name('profiles.permissions');
Route::get('profile/{slug}/permissions/create', 'ACL\ProfilePermissionController@permissionsAvailable');
Route::post('profile/{slug}/permissions/store', 'ACL\ProfilePermissionController@attachPermissionsProfile');
Route::get('profile/{slug}/permissions/{id}/detach', 'ACL\ProfilePermissionController@detachPermissionsProfile');
//Visualizar as permissões dos perfis.
Route::get('permissions/{slug}/profiles', 'ACL\ProfilePermissionController@profiles')->name('permissions.profiles');

/**
 * Routes Planos, Recursos e Perfis dos Planos.
 */
Route::resource('planos', 'PlanController', ['except' => ['edit']]);
Route::resource('planos/{slug}/details', 'PlanDetailsController', ['except' => ['create', 'edit']]);
// Adicionar e remover perfis aos planos.
Route::resource('planos/{slug}/profiles', 'ACL\PlanProfileController', ['except' => ['create', 'edit']]);

// Route url
Route::get('/', 'DashboardController@dashboardAnalytics');

// Route Dashboards
Route::get('/dashboard-analytics', 'DashboardController@dashboardAnalytics');

// Route Components
Route::get('/sk-layout-2-columns', 'StaterkitController@columns_2');
Route::get('/sk-layout-fixed-navbar', 'StaterkitController@fixed_navbar');
Route::get('/sk-layout-floating-navbar', 'StaterkitController@floating_navbar');
Route::get('/sk-layout-fixed', 'StaterkitController@fixed_layout');

app/Models/Plan.php
<?php

namespace App\Models;

use App\Models\ACL\Profile;
use Illuminate\Database\Eloquent\Model;

class Plan extends Model
{
    protected $fillable = ['name', 'slug', 'price', 'description', 'order', 'active'];
    
    
   /**
   * Retorna os detalhes de um plano específico.
   * @return \Illuminate\Database\Eloquent\Relations\HasMany
   */
    public function details()
    {
      return $this->hasMany(PlanDetail::class);
    }
    
    /**
     * Retorna todos as Empresas vinculadas ao plano.
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function companies()
    {
        return $this->hasMany(Company::class);
    }
    
    
    /**
     * Retorna os perfis de um plano.
     *
     * @return \Illuminate\Database\Eloquent\Relations\BelongsToMany
     */
    public function profiles()
    {
        return $this->belongsToMany(Profile::class);
    }
    
    
    public function profilesAvailable()
    {
        $profiles = Profile::whereNotIn('id', function ($query) {
            $query->select('plan_profile.profile_id');
            $query->from('plan_profile');
            $query->whereRaw("plan_id={$this->id}");
        
        })->paginate();
    
        return $profiles;
    }
    
}

app/Http/Controllers/PlanController.php
<?php
    
    namespace App\Http\Controllers;
    
    use App\Models\Plan;
    use App\Services\Settings;
    use App\Http\Requests\PlanRequest;
    
    class PlanController extends Controller
    {
        private $model;
        private $config;
        private $view = 'pages.plans';
    
        public function __construct(Plan $model, Settings $config)
        {
            $this->middleware('auth');
            
            $this->model = $model;
            $this->config = $config;
            $this->pageConfigs = $this->config->pageConfigs('plan');
            $this->breadcrumbs = $this->config->breadcrumbs('plan');
        }
        
        /**
         * Display a listing of the resource.
         *
         * @return \Illuminate\Http\Response
         */
        public function index()
        {
            $plans = $this->model->orderBy('order')->get();
            
            return view("{$this->view}.index", [
                'plans' => $plans,
                'pageConfigs' => $this->pageConfigs,
                'breadcrumbs' => $this->breadcrumbs
            ]);
        }
        
        /**
         * Show the form for creating a new resource.
         *
         * @return \Illuminate\Http\Response
         */
        public function create()
        {
            $form = view("{$this->view}._partials.create")->render();
            $out = [
                'success' => true,
                'modal' => $form
            ];
            return response()->json($out);
        }
        
        /**
         * Store a newly created resource in storage.
         *
         * @param  \App\Http\Requests\PlanRequest $request
         * @return \Illuminate\Http\Response
         */
        public function store(PlanRequest $request)
        {
            $data = $this->model->create($request->except('_token'));
            if ($data) {
                return response()->json(['success' => true, 'message' => 'O Plano foi salvo.']);
            } else {
                return response()->json(['message' => 'Houve um erro não identificado, tente mais tarde.']);
            }
        }
        
        /**
         * Display the specified resource.
         *
         * @param  string  $slug
         * @return \Illuminate\Http\Response
         */
        public function show($slug)
        {
            $data = $this->model->whereSlug($slug)->first();
            $form = view("{$this->view}._partials.edit", ['data' => $data])->render();
            $out = [
                'success' => true,
                'modal' => $form
            ];
            
            return response()->json($out);
        }
        
        
        
        /**
         * Update the specified resource in storage.
         *
         * @param  \App\Http\Requests\PlanRequest $request
         * @param  string  $slug
         * @return \Illuminate\Http\Response
         */
        public function update(PlanRequest $request, $slug)
        {
            $input = $request->except('_token', '_method');
            
            $data = $this->model->whereSlug($slug)->first();
            if ( $data->update($input) )  {
                return response()->json(['success' => true, 'message' => 'O Plano foi alterado com sucesso.']);
            } else {
            
            }
            
        }
        
        /**
         * Remove the specified resource from storage.
         *
         * @param  string  $slug
         * @return \Illuminate\Http\Response
         */
        public function destroy($slug)
        {
            $data = $this->model->whereSlug($slug)->first();
            if ($data->delete())
                $out = [
                    'success' => true,
                ];
            
            return response()->json($out);
        }
    }

resources/views/pages/plans/_partials/create.blade.php
<div class="modal-header bg-primary">
  <h4 class="modal-title" id="titleModalPlans">Adicionar Plano</h4>
  <button type="button" class="close" data-dismiss="modal" aria-label="Fechar"><span aria-hidden="true">&times;</span></button>
</div>

<form id="form-plans" action="{{route('planos.store')}}" class="form form-horizontal" onsubmit="return false">
  <div class="modal-body">
    @include('pages.plans._partials.form')
  </div>
  <div class="modal-footer">
    <div class="col-12">
      <button type="reset" id="btn-reset" class="btn btn-outline-warning mr-1 mb-1 waves-effect waves-light d-none">Limpar</button>
      <button type="submit" id="btn-submit" class="btn btn-primary mr-1 mb-1 waves-effect waves-light">Salvar</button>
    </div>
  </div>
  <div id="methods" class="d-none">
    @csrf
  </div>
</form>

resources/views/pages/plans/_partials/edit.blade.php
<div class="modal-header bg-primary">
  <h4 class="modal-title" id="titleModalPlans">Editar {{$data->name}}</h4>
  <button type="button" class="close" data-dismiss="modal" aria-label="Fechar"><span aria-hidden="true">&times;</span></button>
</div>

<form id="form-plans" action="{{route('planos.update', $data->slug)}}" class="form form-horizontal" onsubmit="return false">
  <div class="modal-body">
    @include('pages.plans._partials.form')
  </div>
  <div class="modal-footer">
    <div class="col-12">
      <button type="submit" id="btn-submit" class="btn btn-primary mr-1 mb-1 waves-effect waves-light">Alterar</button>
    </div>
  </div>
  <div class="d-none">
    @csrf
    @method('put')
  </div>
</form>

resources/views/pages/plans/_partials/form.blade.php
<div id="messages-modal"></div>

<label>Nome: </label>
<div class="form-group">
  <div class="controls">
    <input type="text" id="name" name="name" value="{{$data->name ?? ''}}" class="form-control"  placeholder="Nome do plano">
  </div>
</div>

<label>Preço: </label>
<div class="form-group">
  <div class="controls">
    <input type="text" id="price" name="price" value="{{$data->price ?? ''}}"placeholder="Valor do plano" class="form-control">
  </div>
</div>

<label>Descrição: </label>
<div class="form-group">
  <div class="controls">
      <textarea class="form-control" id="description" name="description" rows="3" placeholder="Descição do plano...">{{$data->description ?? ''}}</textarea>
  </div>
</div>
<div class="form-body">
  <div class="form-group row">
    <div class="col-md-8">
      <label>Status: </label>
      <ul class="list-unstyled mb-0">
        <li class="d-inline-block mr-2">
          <fieldset>
            <div class="vs-radio-con vs-radio-success">
              @isset($data)
                <input type="radio" name="active" value="1" @if($data->active == 1) checked @endif>
              @else
                <input type="radio" name="active" value="1" checked>
              @endisset
              <span class="vs-radio">
                  <span class="vs-radio--border"></span>
                  <span class="vs-radio--circle"></span>
              </span>
              <span class="">Ativo</span>
            </div>
          </fieldset>
        </li>
        <li class="d-inline-block mr-2">
          <fieldset>
            <div class="vs-radio-con vs-radio-danger">
              @isset($data)
                <input type="radio" name="active" value="0" @if($data->active == 0) checked @endif>
              @else
                <input type="radio" name="active" value="0">
              @endisset
              <span class="vs-radio">
                  <span class="vs-radio--border"></span>
                  <span class="vs-radio--circle"></span>
              </span>
              <span class="">Inativo</span>
            </div>
          </fieldset>
        </li>
      </ul>
    </div>
    <div class="col-md-4">
      <label>Ordem: </label>
      <div class="input-group">
        <input type="number" name="order" class="touchspin" value="{{$data->order ?? 1}}">
      </div>
    </div>
  </div>
</div>
<script src="{{ asset(mix('js/scripts/forms/number-input.js')) }}"></script>
<script>
  $('#btn-submit').on('click', function() {
    let form = $('#form-plans'),
      url = form.attr('action');
    $.ajax({
      type: 'POST',
      dataType: "json",
      url: url,
      data: form.serialize(),
      beforeSend: function() {
        $('#btn-submit').prop("disabled", true);
      },
      success: function(data){
        if (data.success == true) {
          let msg = displayAlert('success', data.message)
          $('#btn-reset').trigger('click');
          $('#messages-modal').html(msg);

          setTimeout(function() {
            $('#modalPlans').modal('hide');
            window.location.href = _configPlans.url;
          }, 3000);

        } else {
          alert('Algo aconteceu');
          return false;
        }
      },
      error: function(xhr) {
        $('#btn-submit').prop("disabled", false);
        let msg = errorStatus(xhr);
        $('#messages-modal').html(msg);
        setTimeout(function() {
          $('#messages-modal').html('');
        }, 3000);
      }

    });
  });

</script>

resources/views/pages/plans/_partials/modal.blade.php
<div class="modal fade text-left" id="modalPlans" tabindex="-1" role="dialog" aria-labelledby="titleModalPlans" aria-hidden="true">
    <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable" role="document">
        <div class="modal-content"> </div>
    </div>
</div>